function color = value2color(value, colorMap)
% color = value2color(value, colorMap)
% maps values to colors using the given colorMap
% normalize values

if nargin<2
    colorMap = jet;
end;

value = value - min(value);
value = value / max(value);

% project to colornap
ids = ceil(value * size(colorMap,1));
ids = max(1, ids);
ids = min(size(colorMap,1), ids);

color = colorMap(ids,:);
